{$M, 16384, 0, 655360}
USES
  Dos, Crt,
  GUtils, GMemory;

CONST
  evDialogBack   = 9;     cDialogBack   = 7;
  evButtonBack   = 144;   cButtonBack   = 112;
  evButtonFace   = 112;   cButtonFace   = 32;
  evButtonSelect = 241;   cButtonSelect = 47;
  Info           = ' Information ';
  GamesFileName  = 'FULL.GBC';
  SelectFileName = 'SELECT.GBC';
  MaxLength      = 37;
  Key1           = $D5;
  Key2           = $4A;

TYPE
  TDataInfo = RECORD
    GName   : ARRAY[1..MaxLength] OF Char;
    GType   : ARRAY[1..MaxLength] OF Char;
    GLOG    : ARRAY[1..8] OF Char;
    GCga,
    GEga,
    GVga,
    GSound,
    GCrack  : Boolean;
    GSize   : LongInt;
  END;

  PGameInfo = ^TGameInfo;
  TGameInfo = OBJECT( TObject )
     Name   : STRING[ MaxLength ];
     Tipe   : STRING[ MaxLength ];
     Log    : STRING[ 8 ];
     SB,
     Cga,
     Ega,
     Vga,
     Cracked,
     Selected: Boolean;
     Size    : LongInt;
     CONSTRUCTOR Init( NewName: STRING;
                       NewType: STRING;
                       NewLog: STRING;
                       NewCga,
                       NewEga,
                       NewVga,
                       NewSound,
                       NewCrack: Boolean;
                       NewSize: LongInt );
  END;

  PGameCollection = ^TGameCollection;
  TGameCollection = OBJECT( TSortedCollection )
    FUNCTION KeyOf( Item: Pointer ) : Pointer; VIRTUAL;
    FUNCTION Compare( Key1, Key2: Pointer ) : Integer; VIRTUAL;
  END;

VAR
  DataFileName: STRING;
  Catalog: PGameCollection;
  AnEntry: PGameInfo;
  TmEntry: PGameInfo;
  TheData: TDataInfo;

  DialogBack,
  ButtonBack,
  ButtonShadow,
  ButtonFace,
  ButtonSelect  : Byte;

  I,
  MaxGames,
  MaxSelect,
  GamesCrack,
  SelectCrack,
  InsPosition,
  MenuPosition: Word;

  GamesSize,
  SelectSize,
  DiskFreeSize: LongInt;

  Changed,
  CyrilicKB: Boolean;

  Buffer : Pointer;
  OldX   : Byte;
  OldY   : Byte;

PROCEDURE SaveScreen;
BEGIN
  OldX := WhereX;
  OldY := WhereY;
  GetMem( Buffer, 4000 );
  PartSave( 1, 1, 80, 25, Buffer^ );
END;

PROCEDURE RestoreScreen;
BEGIN
  PartRestore( 1, 1, 80, 25, Buffer^ );
  GotoXY( OldX, OldY );
  FreeMem( Buffer, 4000 );
END;

FUNCTION CString( S: STRING; NewLen: Byte ): STRING;
VAR I: Byte;
BEGIN
  FOR I := 1 TO ( NewLen - Length( S ) ) DIV 2 DO S := ' ' + S + ' ';
  WHILE Length( S ) < NewLen DO S := S + ' ';
  CString := S;
END;

PROCEDURE ExtWrite( S : STRING; Color: Byte;
                    S1: STRING; Color1: Byte );
VAR I:Byte; C:Boolean;
BEGIN
  TextColor( Color ); Write( S  );
  TextColor( Color1); C := False;
  FOR I := 1 TO Length(S1) DO
  BEGIN
    IF S1[I] = '"' THEN
    BEGIN
      C := NOT C;
      S1[I] := ' ';
      IF C THEN TextColor(15) ELSE TextColor(Color1);
    END;
    Write(S1[I]);
  END;
END;

FUNCTION Convert( This: LongInt ) : STRING;
VAR
  S: STRING;
  A,
  B: Byte;

BEGIN
  Str( This, S );
  A := 1;
  FOR B := Length( S ) DOWNTO 2 DO
  BEGIN
    Inc( A );
    IF A = 4 THEN
    BEGIN
      Insert( ',', S ,B );
      A := 1;
    END;
  END;
  Convert := S;
END; { Convert }

{--------------------------}
{ Show information windows }
{--------------------------}
PROCEDURE AboutProgram;
BEGIN
  OpenWin(10, 3, 61, 19, White, Cyan, {True,} cyrDouble, ' About ');
  TextAttr := 48;
  Writeln;
  WriteCStr(60, True, 'GBASE Version 2.2');
  WriteCStr(60, True, 'Copyright (C) 1994-95 by The GodFather');
  Writeln; TextColor(14);
  WriteCStr(62, True, 'This is a SPECIAL version of GBASE. So don''t try');
  WriteCStr(62, True, 'to  use a standart  database file ( GBASE.DAT ),');
  WriteCStr(62, True, 'because this  may cause many problems to you !!!');
  Writeln; TextColor(15);
  WriteCStr(60, True, 'If you wish a simular version but adapted for your');
  WriteCStr(60, True, 'needs, just find  me and I  will make it  for you.');
  WriteCStr(60, True, 'Of course you must give me something.');
  Writeln; TextColor(14);
  WriteCStr(61, True, 'You contact me here:');
  Writeln; TextColor(0);
  WriteCStr(62, True, 'EMAIL: gf@top.bg');
  WriteCStr(60, True, 'EMAIL: gf@cybcom.net');
  WriteCStr(60, True, 'URL: http://georgi.top.bg/');
  Pause;
  RmWin;
END { AboutProgram };
{------------------------------------------------}

PROCEDURE GeneralHelp;
BEGIN
  MkWin( 17, 4, 50, 17, White, Cyan, True, cyrDouble, ' Main help ');
  Writeln;
  ExtWrite('      F1 ', 14, '-"HELP"'#13#10, 0);
  ExtWrite('      F2 ', 14, '-"SAVE"DATABASE file'#13#10,0);
  ExtWrite('      F3 ', 14, '-"WRITE SELECTED"games to"TEXT"file'#13#10,0);
  ExtWrite('      F4 ', 14, '-"WRITE ALL"games to"TEXT"file'#13#10,0);
  ExtWrite('      F5 ', 14, '-"ADD"game'#13#10,0);
  ExtWrite('      F6 ', 14, '-"EDIT"game'#13#10,0);
  ExtWrite('      F7 ', 14, '-"DELETE"game'#13#10,0);
  ExtWrite('      F8 ', 14, '-"UNSELECT ALL"selected games'#13#10,0);
  ExtWrite('      F9 ', 14, '-"STATISTICS"about catalog'#13#10,0);
  ExtWrite('     F10 ', 14, '-"ABOUT"program and author'#13#10#13#10,0);
  ExtWrite('  Alt+F1 ', 14, '-"HELP"for shortcut keys'#13#10,0);
  ExtWrite('   Space ', 14, '-"SELECT"or"UNSELECT"game'#13#10,0);
  ExtWrite('     Esc ', 14, '-"QUIT"from"GBASE"',0);
  Pause;
  RmWin;
END { GeneralHelp };

PROCEDURE SecondaryHelp;
BEGIN
  MkWin( 17, 3, 50, 19, White, Cyan, True, cyrDouble, ' Shortcut help ');
  Writeln;
  ExtWrite('   Alt+C ', 14, '- Add or remove"CGA"support'#13#10,0);
  ExtWrite('   Alt+E ', 14, '- Add or remove"EGA"support'#13#10,0);
  ExtWrite('   Alt+V ', 14, '- Add or remove"VGA"support'#13#10,0);
  ExtWrite('   Alt+B ', 14, '- Add or remove"SOUND BLASTER"support'#13#10, 0);
  ExtWrite('   Alt+R ', 14, '- Add or remove"CRACKED"flag'#13#10,0);
  ExtWrite('   Alt+3 ', 14, '- Set"TYPE"to"3D Action"'#13#10,0);
  ExtWrite('   Alt+A ', 14, '- Set"TYPE"to"Action"'#13#10,0);
  ExtWrite('   Alt+D ', 14, '- Set"TYPE"to"Driving"'#13#10,0);
  ExtWrite('   Alt+L ', 14, '- Set"TYPE"to"Logical"'#13#10,0);
  ExtWrite('   Alt+O ', 14, '- Set"TYPE"to"Sport"'#13#10,0);
  ExtWrite('   Alt+P ', 14, '- Set"TYPE"to"Platform"'#13#10,0);
  ExtWrite('   Alt+Q ', 14, '- Set"TYPE"to"Quest"'#13#10,0);
  ExtWrite('   Alt+S ', 14, '- Set"TYPE"to"Strategic"'#13#10,0);
  ExtWrite('   Alt+T ', 14, '- Set"TYPE"to"Tetris"'#13#10,0);
  ExtWrite('   Alt+N ', 14, '- Set"TYPE"to"No type defined"'#13#10,0);
  ExtWrite('   Alt+X ', 14, '-"QUIT"from"GBASE"without prompting',0);
  Pause;
  RmWin;
END { GeneralHelp };

PROCEDURE HelpOnDialogBox;
BEGIN
  MkWin( 16, 6, 51, 13, White, Cyan, False, cyrDouble, ' Dialog help ');
  Dec( TextAttr, 15 );
  Writeln;
  ExtWrite('   N  ',14,'-  Activate"NAME"field'#13#10, 0);
  ExtWrite('   T  ',14,'-  Activate"TYPE"field'#13#10, 0);
  ExtWrite('   S  ',14,'-  Activate"SIZE"field'#13#10, 0);
  ExtWrite('   L  ',14,'-  Activate"LOG"field'#13#10, 0);
  ExtWrite('   C  ',14,'-  Enable or disable"CGA"button'#13#10, 0);
  ExtWrite('   E  ',14,'-  Enable or disable"EGA"button'#13#10, 0);
  ExtWrite('   V  ',14,'-  Enable or disable"VGA"button'#13#10, 0);
  ExtWrite('   B  ',14,'-  Enable or disable"SOUND BLASTER"button'#13#10, 0);
  ExtWrite('   R  ',14,'-  Enable or disable"CRACKED"button'#13#10, 0);
  Pause;
  RmWin;
END { HelpOnDialogBox };

PROCEDURE ShowStatus;
BEGIN
  MkWin( 14, 5, 55, 14, White, Cyan, True, cyrDouble, ' Statistics ');
  TextAttr := 48;
  Writeln;
  WriteCStr(54, True, 'Catalog');
  Writeln;
  ExtWrite('       Games        - ', 0, Convert( MaxGames )+#13#10, 14);
  ExtWrite('       Cracked      - ', 0, Convert( GamesCrack )+#13#10, 14);
  ExtWrite('       Games size   - ', 0, Convert( GamesSize )+' Bytes'#13#10#13#10,14);
  TextAttr := 48;
  WriteCStr(56, True, 'Selected games');
  Writeln;
  ExtWrite('       Games        - ', 0, Convert( MaxSelect )+#13#10, 14);
  ExtWrite('       Cracked      - ', 0, Convert( SelectCrack )+#13#10, 14);
  ExtWrite('       Games size   - ', 0, Convert( SelectSize )+' Bytes'#13#10,14);
  Pause;
  RmWin;
END { ShowStatus };

{--------------------------------------}
{ Collection initialization procedures }
{--------------------------------------}
CONSTRUCTOR TGameInfo.Init
              ( NewName: STRING;
                NewType: STRING;
                NewLog : STRING;
                NewCga,
                NewEga,
                NewVga,
                NewSound,
                NewCrack: Boolean;
                NewSize: LongInt );
BEGIN
  Name    := NewName;
  Tipe    := NewType;
  Log     := NewLog;
  SB      := NewSound;
  Cga     := NewCga;
  Ega     := NewEga;
  Vga     := NewVga;
  Cracked := NewCrack;
  Selected:= False;
  Size    := NewSize;
END; { Init }

FUNCTION TGameCollection.KeyOf( Item: Pointer ) : Pointer;
BEGIN
  KeyOf := @PGameInfo( Item )^.Name;
END; { KeyOf }

FUNCTION TGameCollection.Compare( Key1, Key2: Pointer ) : Integer;
BEGIN
  IF STRING( Key1^ ) = STRING( Key2^ ) THEN
    Compare := 0
  ELSE
  IF STRING( Key1^ ) < STRING( Key2^ ) THEN
    Compare := -1
  ELSE
    Compare := 1;
END; { Compare }
{------------------------------------------------}

PROCEDURE Error( Arg: STRING );
BEGIN
  Dispose( Catalog, Done );
  RmWin;
  Writeln;
  Writeln( Arg );
  Halt( 1 );
END; { Error }

PROCEDURE UpdateChange( Chng: Boolean );
VAR TmCh: Char;
BEGIN
  Changed := Chng;
  IF Changed THEN TmCh := '*' ELSE TmCh := ' ';
  FastWrite( 78, 25, Attr( 4, 7 ), TmCh );
END;

PROCEDURE UpdateCyrilic( Beep: Boolean );
VAR TStr: STRING;
BEGIN
  CyrilicKB := NOT CyrilicKB;
  IF CyrilicKB THEN TStr := 'Cyrilic' ELSE TStr := '       ';
  FastWrite( 69, 25, Attr( 4, 7 ), TStr );
  IF Beep THEN
  BEGIN
    Sound( 70  ); Delay( 40 ); NoSound;
    Sound( 100 ); Delay( 100); NoSound;
    REPEAT UNTIL NOT AltPressed AND NOT LeftShiftPressed;
  END;
END;

{$F+}
PROCEDURE CyrilicHook;
BEGIN
  IF AltPressed AND LeftShiftPressed THEN UpdateCyrilic( True );
END;
{$F-}

PROCEDURE TheEnd;
BEGIN
  Dispose( Catalog, Done );
  Dispose( TmEntry );
  Load8x16;
  RestoreScreen;
  Cursor( On );
  TextAttr := 14;
  Writeln;
  WriteCStr(80, False, 'Thank you for using GBASE by The GodFather');
  TextAttr := 7; Writeln(' ');
  Halt( 0 );
END; { TheEnd }
{------------------------------------------------}

{-------------------------------------}
{ Dialog boxes and boxes for massages }
{-------------------------------------}
PROCEDURE WaitBox;
BEGIN
  MkWin(22, 8, 40, 4, White, Red, True, cyrDouble, Info );
  Writeln;
  WriteCStr(40, False, 'Please wait . . . ' );
END; { Wait Box }

PROCEDURE InfoBox( Arg: STRING );
VAR
  OK: PBCollection;

BEGIN
  OK := New( PBCollection, Init( 1, 1 ) );
  OK^.Insert( New( PButton, Init('    OK    ', ' ', 21, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  MkWin( 15, 7, 52, 8, White, DialogBack, True, cyrDouble, Info );
  Writeln(#13#10);
  Dec( TextAttr );
  WriteCStr( 52, False, Arg );
  OK^.Choose( 0 );
  Dispose( OK, Done );
  RmWin;
END; { InfoBox }

FUNCTION PromptBox( Arg: STRING ) : Boolean;
VAR YN: PBCollection;
BEGIN
  YN := New( PBCollection, Init( 2, 1 ) );
  YN^.Insert( New( PButton, Init('    OK    ', ' ', 10, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('  Cancel  ', ' ', 32, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  PromptBox := False;
  MkWin(15, 7, 52, 8, White, DialogBack, True, cyrDouble, Info );
  Writeln(#13#10);
  WriteCStr( 52, False, Arg );
  YN^.Choose( 0 );
  IF NOT YN^.EscPressed AND (YN^.ButtonNumb = 0) THEN PromptBox := True;
  Dispose( YN, Done );
  RmWin;
END; { PromptBox }
{------------------------------------------------}

{---------------------------------}
{ Read catalog from database file }
{---------------------------------}
PROCEDURE ReadDataFile;
VAR
  F     : FILE;
  S, Typ: STRING[50];
  Lg    : STRING[8];
  Zero  : Boolean;
  OLen  : Boolean;
  I, R  : Word;

BEGIN
  DataFileName := 'GBASE-SP.DAT';
  Assign( F, DataFileName );
  {$I-}
    Reset( F, 1 );
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    DataFileName := FSearch( DataFileName, GetEnv('PATH') );
    Assign( F, DataFileName );
    {$I-}
     Reset( F, 1 );
    {$I+}
    IF (IOResult <> 0) OR (DataFileName = '')
      THEN Error('Can''t find GBASE-SP.DAT');
  END;
  FOR I := 1 TO FileSize( F ) DIV SizeOf( TheData ) DO
  BEGIN
    BlockRead(F, TheData, SizeOf( TheData ), R );
    IF IOResult <> 0 THEN Error('Read Error');
    Seek( F, I * SizeOf( TheData ) );
    IF IOResult <> 0 THEN Error('Seek Error');
    WITH TheData DO
    BEGIN
      OLen := False;
      FOR R := 1 TO MaxLength DO
      BEGIN
        S[R] := Chr( Ord( GName[R] ) XOR Key1 XOR Key2 );
        IF S[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN S[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN S[R] := #0;
      END;
      OLen := False;
      FOR R := 1 TO MaxLength DO
      BEGIN
        Typ[R] := Chr( Ord( GType[R] ) XOR Key1 XOR Key2 );
        IF Typ[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN Typ[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN Typ[R] := #0;
      END;
      OLen := False;
      FOR R := 1 TO 8 DO
      BEGIN
        Lg[R] := Chr( Ord( GLOG[R] ) XOR Key1 XOR Key2 );
        IF Lg[R] = #0 THEN
        BEGIN
          IF NOT OLen THEN Lg[0] := Chr( R - 1 );
          OLen := True;
          Zero := True
        END ELSE Zero := False;
        IF Zero THEN Lg[R] := #0;
      END;
      GSize  := GSize  XOR Key1 XOR Key2;
      GSize := GSize;
      Inc( GamesSize, GSize );
      IF GCrack THEN Inc( GamesCrack );
      IF MemAvail < 100 THEN
      BEGIN
        Catalog^.Done;
        Error('Catalog is too large. Contact with The GodFather');
      END;
      Catalog^.Insert( New( PGameInfo,
                 Init( S, Typ, Lg,
                       GCga, GEga, GVga,
                       GSound, GCrack,
                       GSize )));
    END;
  END;
  Close( F );
END; { ReadDataFile }
{------------------------------------------------}

{--------------------------------}
{ Write catalog to database file }
{--------------------------------}
PROCEDURE WriteDataFile( MassageBox: Boolean );
VAR F: FILE;

  PROCEDURE WriteEntry( OneEntry: PGameInfo ); FAR;
  VAR Written, R: Word;
  BEGIN
    WITH TheData DO
    WITH OneEntry^ DO
    BEGIN
      FOR R := 1 TO MaxLength DO
      BEGIN
        IF R <= Length( Name )
          THEN GName[R] := Name[R]
          ELSE GName[R] := Chr( Random( 255 ) );
        GName[R] := Chr( Ord( GName[R] ) XOR Key1 XOR Key2 );
        IF R <= Length( Tipe )
          THEN GType[R] := Tipe[R]
          ELSE GType[R] := Chr( Random( 255 ) );
        GType[R] := Chr( Ord( GType[R] ) XOR Key1 XOR Key2 );
      END;
      FOR R := 1 TO 8 DO
      BEGIN
        IF R <= Length( LOG )
          THEN GLOG[R] := LOG[R]
          ELSE GLOG[R] := Chr( Random( 255 ) );
        GLOG[R] := Chr( Ord( GLOG[R] ) XOR Key1 XOR Key2 );
      END;
      GName[ Length( Name ) + 1 ] := #159;
      GType[ Length( Tipe ) + 1 ] := #159;
      GLOG [ Length( LOG  ) + 1 ] := #159;
      GCga   := Cga;
      GEga   := Ega;
      GVga   := Vga;
      GCrack := Cracked;
      GSound := SB;
      GSize  := Size  XOR Key1 XOR Key2;
    END;
    BlockWrite(F, TheData, SizeOf( TheData ), Written);
  END;

BEGIN
  IF DiskFreeSize < MaxGames * SizeOf( TheData )
  THEN InfoBox('Not Enough free space')
  ELSE
  BEGIN
    WaitBox;
    Assign( F, DataFileName );
    Rewrite( F, 1 );
    Catalog^.ForEach( @WriteEntry );
    Close( F );
    RmWin;
    IF MassageBox THEN InfoBox('DATABASE file is written');
    UpdateChange( False );
  END;
END; { WriteDataFile }
{------------------------------------------------}

{----------------------------}
{ Print catalog to text file }
{----------------------------}
PROCEDURE WriteTextFile( OnlySelected: Boolean );
VAR
  F   : Text;
  Buf : Pointer;
  FName: STRING;
  Temp: STRING;
  SFlag,
  CFlag,
  EFlag,
  VFlag: Word;
  MGames,
  GCrack: Word;
  GSize: LongInt;

  PROCEDURE PrintEntry( OneEntry: PGameInfo ); FAR;
  VAR R: Byte; Tmp: Boolean;
  BEGIN
    WITH OneEntry^ DO
    BEGIN
      IF NOT OnlySelected THEN
      BEGIN
        Tmp      := Selected;
        Selected := True;
      END;
      IF Selected THEN
      BEGIN
        Write(F, ' ',Convert( Size ):10,'  ');
        IF Cga THEN Write(F, 'C') ELSE Write(F, '-');
        IF Ega THEN Write(F, 'E') ELSE Write(F, '-');
        IF Vga THEN Write(F, 'V') ELSE Write(F, '-');
        IF SB  THEN Write(F, '  * ') ELSE Write(F, '    ');
        IF Cracked THEN Write(F, ' Y ') ELSE Write(F, '   ');
        IF Cga THEN Inc( CFlag );
        IF Ega THEN Inc( EFlag );
        IF Vga THEN Inc( VFlag );
        IF SB  THEN Inc( SFlag );
        Write(F, ' ' ,Name); FOR R := Length( Name ) TO 36 DO Write(F, #32);
        Write(F, ' ',Tipe); FOR R := Length( Tipe ) TO 36 DO Write(F, #32);
        Write(F,' ',LOG+'.LOG'); FOR R := Length( LOG ) + 4 TO 11 DO Write(F, #32);
        Writeln(F,'');
      END;
      IF NOT OnlySelected THEN Selected := Tmp;
    END;
  END;

BEGIN
  CFlag := 0;  EFlag := 0;
  VFlag := 0;  SFlag := 0;
  IF OnlySelected THEN
  BEGIN
    MGames := MaxSelect;
    GCrack := SelectCrack;
    GSize  := SelectSize;
    FName  := SelectFileName;
  END ELSE
  BEGIN
    MGames := MaxGames;
    GCrack := GamesCrack;
    GSize  := GamesSize;
    FName  := GamesFileName;
  END;
  IF DiskFreeSize < (MGames  * 110) + 1000
  THEN InfoBox('Not enough free space on disk')
  ELSE
  BEGIN
    GetMem( Buf, 32767 );
    WaitBox;
    Assign( F, FName );
    Rewrite( F );
    SetTextBuf( F, Buf^, 32767 );
    Writeln(F);
    Writeln(F,Replicate(79,''));
    Writeln(F,CString('Malin Krastev',79));
    Writeln(F,CString('Pazardjik 4400',79));
    Writeln(F,CString('st. "Antim 1st" N23 fl.3 ap.9',79));
    Writeln(F,CString('/034/ 2-36-49',79));
    Writeln(F,Replicate(79,''),#13#10);
    Writeln(F,CString('This catalog is created with GBASE Version 2.2',79),#13#10);
    Writeln(F,'     Size     Video Snd Crk  Name       '+
              '                            Type       ' +
              '                            LOG Name');
    Writeln(F,''+
              'Ŀ');
    Catalog^.ForEach( @PrintEntry );
    Writeln(F,''+
              ''#13#10);
    Writeln(F,'      Games in catalog ................... ', MGames);
    Writeln(F,'      Games which support CGA ............ ', CFlag );
    Writeln(F,'      Games which support EGA ............ ', EFlag );
    Writeln(F,'      Games which support VGA ............ ', VFlag );
    Writeln(F,'      Games which support SOUND BLASTER .. ', SFlag );
    Writeln(F,'      Cracked Games ...................... ', GCrack );
    Writeln(F,'      Games size ......................... ', Convert( GSize ),' bytes'#13#10);
    Close( F );
    FreeMem( Buf, 32767 );
    RmWin;
    InfoBox('Catalog is written to '+FName);
  END;
END; { WriteTextFile }
{------------------------------------------------}

{-----------------------}
{ Edit game information }
{-----------------------}
 PROCEDURE WriteCBox( B: Boolean );
 BEGIN
   TextAttr := Attr(White, DialogBack);  Write('   ');
   TextAttr := 7;
   IF B THEN Write('  [x]') ELSE Write('  [ ]');
 END;

 PROCEDURE UpdateCBox( XPos, YPos: Byte; VAR Sum: Boolean );
 BEGIN
   Sum := NOT Sum;
   GotoXY( XPos, YPos );
   TextAttr := 7;
   IF Sum THEN Write('x') ELSE Write(' ');
 END;

 PROCEDURE WriteHL( S: STRING; Back: Byte; Num: Boolean );
 VAR I: Byte;
 BEGIN
   FOR I := 1 TO Length( S ) DO
     IF S[I] = '~'
       THEN
         BEGIN
           TextAttr := Attr( 14, Back ); Inc( I );
           Write( S[I] );
           IF Num
             THEN Dec( TextAttr, 7 )
             ELSE Inc( TextAttr, 1 );
         END
       ELSE Write( S[I] );
 END;

 PROCEDURE WriteField( S: STRING; FLength, XPos, YPos: Byte; Push : Boolean );
 VAR I, X, Y, OldAttr: Byte;
 BEGIN
   X := WhereX; Y := WhereY;
   GotoXY( XPos-1, YPos );
   OldAttr  := TextAttr;
   TextAttr := 7; Write(' ',S);
   FOR I := Length( S ) TO FLength - 1 DO Write(''); Write(' ');
   TextAttr := OldAttr;
   IF Push THEN GotoXY( X, Y );
 END;

 PROCEDURE EditField( VAR S: STRING;
                      FieldLength,
                      XPos, YPos: Byte;
                      Number,
                      UpperOnly: Boolean );
 VAR
   Key: Char;
   Tst: Char;
   TmpLG: LongInt;
   Code : Integer;
   TempS: STRING;
   TmpCP: Byte;
   EndOfEditing: Boolean;

 BEGIN
   Cursor( On );
   IF (S = 'New game')
       OR (S = 'No type defined')
       OR (S = 'NEW') OR (S = '0')
     THEN TempS := ''
     ELSE TempS := S;
   EndOfEditing := False;
   WriteField( TempS, FieldLength, XPos, YPos, True );
   TmpCP := Length( TempS ) + 1;
   GotoXY( XPos + TmpCP - 1, YPos );
   REPEAT
     Key := GetKey;
     CASE Key OF
       kbLeft: IF TmpCP > 1 THEN
               BEGIN
                 GotoXY( WhereX - 1, WhereY );
                 Dec( TmpCP );
               END;
      kbRight: IF TmpCP < FieldLength THEN
               BEGIN
                 GotoXY( WhereX + 1, WhereY );
                 Inc( TmpCP );
               END;
       kbHome: BEGIN
                 TmpCP := 1;
                 GotoXY( XPos, YPos );
               END;
        kbEnd: BEGIN
                 TmpCP := Length( TempS ) + 1;
                 GotoXY( XPos + TmpCP - 1, YPos );
               END;
     kbBSpace: IF TmpCP > 1 THEN
               BEGIN
                 GotoXY( WhereX - 1, WhereY );
                 Dec( TmpCP );
                 Delete( TempS, TmpCP, 1 );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
        kbDel: BEGIN
                 Delete( TempS, TmpCP, 1 );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
       kbAltD: BEGIN
                 TmpCp := 1;
                 GotoXY( XPos, YPos );
                 TempS := '';
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
     kbSpace..#189:
               IF (Length( TempS ) < FieldLength) AND
                  (TmpCP < Length( TempS ) + 2)
               THEN
               BEGIN
                 IF TmpCP = 1 THEN Key := UpCase( Key );
                 IF UpperOnly THEN Key := UpCase( Key );
                 IF (TempS[TmpCP - 1] = ' ') AND NOT CyrilicKB
                   THEN Key := UpCase( Key );
                 IF CyrilicKB
                   THEN Insert( Translate( Lat, Cyr, Key ), TempS, TmpCP )
                   ELSE Insert( Key, TempS, TmpCP );
                 Inc( TmpCP );
                 GotoXY( WhereX + 1, WhereY );
                 WriteField( TempS, FieldLength, XPos, YPos, True );
               END;
      kbEnter: IF Number
                 THEN
                 BEGIN
                   Val( TempS, TmpLG, Code );
                   IF Code <> 0
                     THEN Key := #0
                     ELSE S := TempS;
                 END
                 ELSE IF TempS <> '' THEN S := TempS;
        kbEsc: BEGIN
                 WriteField( S, FieldLength, XPos, YPos, True );
                 TempS := S;
               END;
     END; { Case }
     IF (Key = kbEnter) AND (TempS <> '') THEN EndOfEditing := True;
     IF Key = kbEsc THEN EndOfEditing := True;
   UNTIL EndOfEditing;
   Cursor( Off );
 END;

 {$F+}
 PROCEDURE HookKeybord( VAR Key: Char );
 VAR
   SizeStr: STRING;
   ErrPos : Integer;
   TempCyr: Boolean;
 BEGIN
   PressedHook := NIL;
   WITH TmEntry^ DO
   BEGIN
     CASE Key OF
       kbF1          : HelpOnDialogBox;
      'N','n','I','i',
      '','','','': EditField( Name, 36, 11, 2, False, False );
      'T','t','','', kbtab: EditField( Tipe, 36, 11, 4, False, False );
      'L','l','','': EditField( Log,   8, 38, 6, False, True );
      'S','s','','': BEGIN
                         Str( Size, SizeStr );
                         EditField( SizeStr, 10, 11, 6, True, False );
                         Val( SizeStr, Size, ErrPos );
                       END;
      'C','c','','': UpdateCBox( 7,  8, Cga );
      'E','e','','': UpdateCBox( 7,  9, Ega );
      'V','v','','': UpdateCBox( 7, 10, Vga );
      'B','b','','': UpdateCBox( 31, 8, SB );
      'R','r','','': UpdateCBox( 31, 9, Cracked );
     END; { CASE }
   END; { WITH }
   PressedHook := @HookKeybord;
 END;
 {$F-}

FUNCTION DialogBox( Title: STRING ) : Boolean;
VAR
  TS: STRING;
  YN: PBCollection;

BEGIN
  MkWin(14, 5, 55, 15, White, DialogBack, True, cyrDouble, Title);
  WITH TmEntry^ DO
  BEGIN
    Str( Size, TS );
    Writeln;
    WriteHL('    ~Name ', DialogBack, False); WriteField( Name, 36, 11, 2, False ); GotoXY(1, 4);
    WriteHL('    ~Type ', DialogBack, False); WriteField( Tipe, 36, 11, 4, False ); GotoXY(1, 6);
    WriteHL('    ~Size ', DialogBack, False); WriteField( TS,   10, 11, 6, False ); GotoXY(27,6);
    WriteHL(' ~Log file ', DialogBack, False); WriteField( Log,  8, 38, 6, False );
    Writeln(#13#10);
    Dec( TextAttr, 16 );
    WriteCBox( Cga ); WriteHL('  Support ~CGA  '#13#10,0,True);
    WriteCBox( Ega ); WriteHL('  Support ~EGA  '#13#10,0,True);
    WriteCBox( Vga ); WriteHL('  Support ~VGA  '#13#10,0,True);
    GotoXY( 25, 8 ); WriteCBox( SB );       WriteHL('  Support S~B  ',0,True);
    GotoXY( 25, 9 ); WriteCBox( Cracked );  WriteHL('  C~racked     ',0,True);
  END;
  YN := New( PBCollection, Init( 2, 1 ) );
  YN^.Insert( New( PButton, Init('    OK    ', ' ', 12, 13, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('  Cancel  ', ' ', 32, 13, ButtonFace, ButtonBack, 0, ButtonSelect )));
  PressedHook := @HookKeybord;
  YN^.Choose( 0 );
  PressedHook := NIL;
  IF NOT YN^.EscPressed AND (YN^.ButtonNumb = 0)
    THEN DialogBox := True
    ELSE DialogBox := False;
  Dispose( YN, Done );
  RmWin;
END; { DialogBox }
{------------------------------------------------}

FUNCTION AddGame : Boolean;
VAR
  AGEntry: PGameInfo;
  S      : STRING;

BEGIN
  TmEntry^.Init( 'New game', 'No type defined', 'NEW',
                 False, False, False, False, False, 0 );
  WITH TmEntry^ DO
  BEGIN
    IF DialogBox(' Add game ') THEN
    BEGIN
      Catalog^.Insert( New( PGameInfo,
                 Init( Name, Tipe, LOG,
                       Cga, Ega, Vga, SB, Cracked, Size )));
      AddGame := True;
      S       := Name;
      UpdateChange( True );
      IF Cracked THEN Inc( GamesCrack );
    END ELSE AddGame := False;
  END;
  FOR I := 0 TO Catalog^.Count - 1 DO
  BEGIN
    AGEntry := Catalog^.At( I );
    IF AGEntry^.Name = S THEN Break;
  END;
  InsPosition := I + 1;
  MaxGames := Catalog^.Count;
END;

FUNCTION EditGame : Boolean;
VAR
  EGEntry: PGameInfo;
  S      : STRING;
  Chk    : Boolean;
  ChkSel : Boolean;
  OldSize: LongInt;

BEGIN
  AnEntry := Catalog^.At( MenuPosition - 1 );
  WITH AnEntry^ DO
  BEGIN
    Chk    := Cracked;
    ChkSel := Selected;
    TmEntry^.Init( Name, Tipe, LOG, Cga, Ega, Vga, SB, Cracked, Size );
    Dec( GamesSize, Size );
    IF Selected THEN Dec( SelectSize, Size );
  END;
  WITH TmEntry^ DO
  BEGIN
    IF DialogBox(' Edit game ') THEN
    BEGIN
      Catalog^.AtFree( MenuPosition - 1 );
      Catalog^.Insert( New( PGameInfo,
                 Init( Name, Tipe, LOG,
                       Cga, Ega, Vga, SB, Cracked, Size )));
      EditGame := True;
      S        := Name;
      IF NOT Chk AND Cracked THEN Inc( GamesCrack );
      IF Chk AND NOT Cracked THEN Dec( GamesCrack );
      Inc( GamesSize, Size );
      UpdateChange( True );
    END ELSE EditGame := False;
  END;

  FOR I := 0 TO Catalog^.Count - 1 DO
  BEGIN
    EGEntry := Catalog^.At( I );
    IF EGEntry^.Name = S THEN Break;
  END;
  WITH EGEntry^ DO
  BEGIN
    IF ChkSel THEN Selected := True;
    IF Selected THEN
    BEGIN
      IF NOT Chk AND Cracked THEN Inc( SelectCrack );
      IF Chk AND NOT Cracked THEN Dec( SelectCrack );
      Inc( SelectSize, Size );
    END;
  END;
  InsPosition := I + 1;
END;

{--------------------------}
{ Delete game from catalog }
{--------------------------}
FUNCTION DeleteGame : Boolean;
BEGIN
  IF MaxGames < 25 THEN
  BEGIN
    InfoBox('In catalog must have at least 25 games');
    Exit;
  END;

  IF PromptBox('Delete game from catalog ?') THEN
  BEGIN
    AnEntry := Catalog^.At( MenuPosition - 1 );
    WITH AnEntry^ DO
    BEGIN
      Dec( GamesSize, Size );
      IF Cracked THEN Dec( GamesCrack );
      IF Selected THEN
      BEGIN
        Dec( MaxSelect );
        Dec( SelectSize, Size );
        IF Cracked THEN Dec( SelectCrack );
      END;
    END;
    Catalog^.AtFree( MenuPosition - 1 );
    MaxGames   := Catalog^.Count;
    DeleteGame := True;
    UpdateChange( True );
  END ELSE DeleteGame := False;
END;

PROCEDURE AlternateExit;
VAR YN: PBCollection;

 PROCEDURE Bye;
 BEGIN
   Dispose( YN, Done );
   RmWin;
 END;

BEGIN
  YN := New( PBCollection, Init( 3, 1 ) );
  YN^.Insert( New( PButton, Init('    OK    ',' ', 5,  6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('    No    ',' ', 20, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  YN^.Insert( New( PButton, Init('  Cancel  ',' ', 35, 6, ButtonFace, ButtonBack, 0, ButtonSelect )));
  MkWin( 16, 7, 52, 8, White, DialogBack, True, cyrDouble, Info );
  Writeln(#13#10);
  WriteCStr( 52, False, 'DATABASE has been modified. SAVE ?' );
  YN^.Choose( 0 );
  IF NOT YN^.EscPressed
    THEN
    CASE YN^.ButtonNumb OF
      0: BEGIN
           Bye;
           WriteDataFile( False );
           RmWin;
           RmWin;
           RmWin;
           TheEnd;
         END;
      1: BEGIN
           Bye;
           RmWin;
           RmWin;
           TheEnd;
         END;
      2: Bye;
    END
    ELSE Bye;
END;

{----------------------------}
{ Procedures for INFO WINDOW }
{----------------------------}
PROCEDURE InitInfoWindow;
BEGIN
  FBox(41, 2, 80, 24, White, Blue, cyrDouble );
  WriteBetween( 41, 80, 2, White, Blue, ' Game info ');
  WriteAt(42, 3, Yellow, Blue, ' Name:');
  WriteAt(42, 6, Yellow, Blue, ' Video:');
  WriteAt(42, 9, Yellow, Blue, ' Sound:');
  WriteAt(42, 12, Yellow, Blue, ' Size:');
  WriteAt(42, 15, Yellow, Blue, ' Cracked:');
  WriteAt(42, 18, Yellow, Blue, ' Type:');
  WriteAt(42, 21, Yellow, Blue, ' LOG File:');
END; { InitInfoWindow }

PROCEDURE UpdateInfoWindow( Position: Word );
VAR
  AnEntry: PGameInfo;
  Empty  : STRING[40];
  TmpStr : STRING[40];

  PROCEDURE WTM( Y: Byte; S: STRING );
  BEGIN
    FastWrite( 43, Y, Attr( 15, 1 ), Empty );
    FastWrite( 43, Y, Attr( 15, 1 ), S  );
  END;

BEGIN
  AnEntry := Catalog^.At( Position - 1 );
  FillChar( Empty, 38, 0 );
  Empty[0] := Chr( 37 );
  WITH AnEntry^ DO
  BEGIN
    WTM( 4,  Name );
    WTM( 19, Tipe );
    TmpStr := '';
    IF Cga THEN TmpStr := Concat( TmpStr, 'CGA ');
    IF Ega THEN TmpStr := Concat( TmpStr, 'EGA ');
    IF Vga THEN TmpStr := Concat( TmpStr, 'VGA ');
    WTM( 7, TmpStr );
    IF SB
      THEN TmpStr := 'Sound Blaster or Adlib'
      ELSE TmpStr := 'PC Speaker';
    WTM( 10, TmpStr );
    WTM( 13, Convert( Size ) + ' Bytes');
    IF Cracked
      THEN TmpStr := 'Yes!'
      ELSE TmpStr := 'No';
    WTM( 16, TmpStr );
    WTM( 22, LOG+'.LOG');
  END;
END; { UpdateData }
{------------------------------------------------}

{-----------------}
{ Initialize menu }
{-----------------}
PROCEDURE ViewGames;
CONST
  YEnd                = 22;
  BarLength           = 38;
  MenuAttrib          = 71;
  MenuSelectedAttrib  = 79;
  BackAttrib          = 23;
  BackSelectedAttrib  = 31;

VAR
  Y  : Byte;
  Key: Char;

  PROCEDURE Print( Position: Word; YPos: Byte; Attr: Byte );
  VAR
    GetText: STRING;
    TempEntry: PGameInfo;

  BEGIN
    TempEntry := Catalog^.At( Position );
    GetText   := CString( TempEntry^.Name, 38 );
    IF TempEntry^.Selected THEN
    CASE Attr OF
      BackAttrib: Attr := BackSelectedAttrib;
      MenuAttrib: Attr := MenuSelectedAttrib;
    END;
    FastWrite( 2, YPos + 2, Attr, GetText );
  END;

  PROCEDURE UpdateAll;
  BEGIN
    Print( MenuPosition - 1, Y, MenuAttrib );
    UpdateInfoWindow( MenuPosition );
  END;

  PROCEDURE Written( MPos: Word );
  VAR F: Word;
  BEGIN
    GotoXY( 1, 1 );
    FOR F := MPos TO MPos + 20 DO
    BEGIN
      IF F - (MPos - 1) = Y
        THEN Print( F - 1, (F - (MPos - 1) ), MenuAttrib )
        ELSE Print( F - 1, (F - (MPos - 1) ), BackAttrib );
    END;
  END;

  PROCEDURE SetNewPosition( NewPos: Word );
  BEGIN
    IF NewPos < 10 THEN Y := NewPos
    ELSE IF NewPos > MaxGames-11
      THEN Y := 21 - (MaxGames-NewPos)
      ELSE Y := 10;
    IF NewPos < 10
       THEN Written( 1 )
       ELSE
         IF NewPos > MaxGames - 10
           THEN Written( MaxGames - 20 )
           ELSE IF NewPos <> MaxGames - 10
                  THEN Written( NewPos - 9 )
                  ELSE Written( MaxGames - 20 );
    MenuPosition := NewPos;
    UpdateAll;
  END;

  PROCEDURE SetDelPosition;
  VAR Temp: Integer;
  BEGIN
    IF MenuPosition <> MaxGames + 1 THEN Temp := MenuPosition - Pred( Y );
    IF MenuPosition  = MaxGames + 1 THEN
    BEGIN
      Dec( MenuPosition );
      Temp := MaxGames - 20;
    END;
    IF MenuPosition - 1 >= MaxGames - 20 THEN
    BEGIN
      Dec( MenuPosition );
      Temp := MenuPosition - Pred( Y );
    END;
    Written( Temp );
    UpdateAll;
  END;

  PROCEDURE Search;
  VAR
    Tmp     : Word;
    FoundIt : Boolean;
    TmpEntry: PGameInfo;

  BEGIN
    IF Key IN [#97..#122] THEN Key := Chr( Ord( Key) - 32 );
    FoundIt := False;
    FOR Tmp := 0 TO Catalog^.Count - 1 DO
    BEGIN
      TmpEntry := Catalog^.At( Tmp );
      IF Key = TmpEntry^.Name[1] THEN
      BEGIN
        FoundIt := True;
        Break;
      END;
    END;
    IF ( FoundIt ) AND ( Tmp + 1 <> MenuPosition )
      THEN SetNewPosition( Tmp + 1 );
  END;

  PROCEDURE Move;
  BEGIN
    GotoXY( 1, Y );
    Print( MenuPosition - 1, Y, BackAttrib );
    CASE Key OF
      kbUp  :
        BEGIN
          IF Y = 1 THEN InsLine ELSE Dec( Y );
          Dec( MenuPosition );
        END;
      kbPgUp:
        BEGIN
          Y := 1;
          IF MenuPosition > 21
            THEN Dec( MenuPosition, 20 )
            ELSE MenuPosition := 1;
          Written( MenuPosition );
        END;
      kbHome:
        BEGIN
          Y := 1;
          MenuPosition := 1;
          Written( MenuPosition );
          GotoXY( 1, Y );
        END;
      kbDown:
        BEGIN
          IF Y = 21 THEN WriteLn ELSE Inc( Y );
          Inc( MenuPosition );
        END;
      kbPgDn:
        BEGIN
          Y := YEnd - 1;
          IF MenuPosition < MaxGames - 20
            THEN Inc( MenuPosition, 20 )
            ELSE MenuPosition := MaxGames;
          Written( MenuPosition - 20 );
        END;
      kbEnd :
        BEGIN
          Y := 21;
          MenuPosition := MaxGames;
          Written( MaxGames - 20 );
         END;
    END; { CASE }
    UpdateAll;
  END; { Procedure }

  PROCEDURE DoSelectGame;
  VAR TempEntry: PGameInfo;
  BEGIN
    TempEntry := Catalog^.At( MenuPosition - 1 );
    WITH TempEntry^ DO
    BEGIN
      Selected := NOT Selected;
      IF Selected THEN
      BEGIN
        Inc( MaxSelect );
        Inc( SelectSize, Size );
        IF Cracked THEN Inc( SelectCrack );
      END ELSE
      BEGIN
        Dec( MaxSelect );
        Dec( SelectSize, Size );
        IF Cracked THEN Dec( SelectCrack );
      END;
    END;
    Key := kbDown;
    IF MenuPosition <> MaxGames
      THEN Move
      ELSE Print( MenuPosition - 1, Y, MenuAttrib );
  END;

  PROCEDURE UnSelectGames;
  VAR TempEntry: PGameInfo; I: Word;
  BEGIN
    IF MaxSelect > 0 THEN
    BEGIN
      FOR I := 0 TO Catalog^.Count - 1 DO
      BEGIN
        TempEntry := Catalog^.At( I );
        TempEntry^.Selected := False;
      END;
      MaxSelect   := 0;
      SelectSize  := 0;
      SelectCrack := 0;
      Written( MenuPosition - Pred( Y ) );
      Print( MenuPosition - 1, Y, MenuAttrib );
    END;
  END;

  PROCEDURE Shortcuts;
  VAR Tmp: PGameInfo; Exist: Boolean;
  BEGIN
    Tmp   := Catalog^.At( MenuPosition - 1 );
    Exist := True;
    WITH Tmp^ DO
    BEGIN
      CASE Key OF
        kbAlt3: Tipe := '3D Action';
        kbAltA: Tipe := 'Action';
        kbAltD: Tipe := 'Driving';
        kbAltL: Tipe := 'Logical';
        kbAltO: Tipe := 'Sport';
        kbAltP: Tipe := 'Platform';
        kbAltQ: Tipe := 'Quest';
        kbAltS: Tipe := 'Strategic';
        kbAltT: Tipe := 'Tetris';
        kbAltN: Tipe := 'No type defined';
        kbAltC: Cga  := NOT Cga;
        kbAltE: Ega  := NOT Ega;
        kbAltV: Vga  := NOT Vga;
        kbAltB: SB   := NOT SB;
        kbAltR: Cracked := NOT Cracked;
       ELSE Exist := False;
      END;
    END;
    UpdateInfoWindow( MenuPosition );
    IF Exist THEN UpdateChange( True );
  END;

{ Main procedure }
BEGIN
  Y := 1;
  InitInfoWindow;
  MkWin( 1, 2, 39, 22, White, Blue, False, cyrDouble, ' Catalog ');
  TextAttr := BackAttrib;
  Written( 1 );
  UpdateAll;
  REPEAT
    Key := GetKey;
    Shortcuts;
    CASE Key OF
     #33..#122: Search;
        kbUp,
      kbPgUp,
      kbHome: IF MenuPosition <> 1 THEN Move;
      kbDown,
      kbPgDn,
       kbEnd: IF MenuPosition <> MaxGames THEN Move;
        kbF1: GeneralHelp;
     kbAltF1: SecondaryHelp;
        kbF2: IF PromptBox('Save DATABASE file ?') THEN WriteDataFile( True );
        kbF3: IF MaxSelect = 0
                THEN InfoBox('There''s no selected games')
                ELSE BEGIN
                       IF PromptBox('Write SELECTED games to TEXT file ?')
                         THEN WriteTextFile( True );
                     END;
        kbF4: IF PromptBox('Write ALL games to TEXT file ?') THEN WriteTextFile( False );
        kbF5: IF AddGame    THEN SetNewPosition( InsPosition );
        kbF6: IF EditGame   THEN SetNewPosition( InsPosition );
        kbF7: IF DeleteGame THEN SetDelPosition;
        kbF8: UnSelectGames;
        kbF9: ShowStatus;
       kbF10: AboutProgram;
     kbEnter,
     kbSpace: DoSelectGame;
       kbEsc: IF Changed THEN
              BEGIN
                AlternateExit;
                Key := #0;
              END ELSE
               IF PromptBox('Quit from GBASE ?')
                 THEN RmWin
                 ELSE Key := #0;
      kbAltX: IF Changed THEN
              BEGIN
                AlternateExit;
                Key := #0;
              END ELSE
               BEGIN
                 RmWin;
                 Key := kbEsc;
               END;
    END;
  UNTIL Key = kbEsc;
END; { Menu }
{------------------------------------------------}

{-----------------------------------------}
{ Initialize buttons, font and collection }
{-----------------------------------------}
PROCEDURE Initialize;
BEGIN
  SaveScreen;
  LoadFont( Cyrilic );
  MkWin( 15, 10, 50, 4, White, Red, False, CyrDouble, '' );
  WriteBetween(10,70,12,White,Red,'Please wait loading database . . . .');
  Cursor( Off );
  SetBlink( False );
  DiskFreeSize := DiskFree( 0 );
  Catalog      := New( PGameCollection, Init( 400, 100 ) );
  New( TmEntry );
  CheckBreak   := False;
  CyrilicKB    := False;
  Changed      := False;
  GamesSize    := 0;
  GamesCrack   := 0;
  SelectSize   := 0;
  SelectCrack  := 0;
  MaxSelect    := 0;
  MenuPosition := 1;
  ReadDataFile;
  RmWin;
  MaxGames     := Catalog^.Count;
  Randomize;
  FastWrite( 1, 1,  112, CString('GBASE Version 2.2', 80) );
  FastWrite( 1, 25, 112, ' F1 Help            Copyright (C) 1994'+
                        '-95 by The GodFather                       ');
  FastWrite( 1, 25, 116, ' F1' );
  IdleHook := @CyrilicHook;
END; { Initialize }
{------------------------------------------------}

{--------------}
{ Main Program }
{--------------}
BEGIN
  IF EgaVgaSystem THEN
  BEGIN
    DialogBack   := evDialogBack;
    ButtonBack   := evButtonBack;
    ButtonFace   := evButtonFace;
    ButtonSelect := evButtonSelect;
  END ELSE
  BEGIN
    DialogBack   := cDialogBack;
    ButtonBack   := cButtonBack;
    ButtonFace   := cButtonFace;
    ButtonSelect := cButtonSelect;
  END;
  Initialize;
  ViewGames;
  TheEnd;
END.